import { type GeospatialFieldComponent } from '@defra/forms-model';
import { type ArraySchema } from 'joi';
import { type ComponentBase } from '../../../../server/plugins/engine/components/ComponentBase.js';
import { FormComponent } from '../../../../server/plugins/engine/components/FormComponent.js';
import { type ErrorMessageTemplateList, type FormPayload, type FormState, type FormStateValue, type FormSubmissionError, type FormSubmissionState, type GeospatialState } from '../../../../server/plugins/engine/types.js';
export declare class GeospatialField extends FormComponent {
    options: GeospatialFieldComponent['options'];
    formSchema: ArraySchema<GeospatialState>;
    stateSchema: ArraySchema<GeospatialState>;
    constructor(def: GeospatialFieldComponent, props: ConstructorParameters<typeof ComponentBase>[1]);
    getFormValueFromState(state: FormSubmissionState): import("../../../../server/plugins/engine/types.js").FeatureCollection | undefined;
    getFormValue(value?: FormStateValue | FormState): import("../../../../server/plugins/engine/types.js").FeatureCollection | undefined;
    getDisplayStringFromFormValue(features: GeospatialState | undefined): string;
    getDisplayStringFromState(state: FormSubmissionState): string;
    getContextValueFromFormValue(features: GeospatialState | undefined): string[] | null;
    getContextValueFromState(state: FormSubmissionState): string[] | null;
    getViewModel(payload: FormPayload, errors?: FormSubmissionError[]): {
        country: import("@defra/forms-model").GeospatialFieldOptionsCountry | undefined;
        geometryTypes: import("@defra/forms-model").GeospatialFieldGeometryTypesEnum[] | undefined;
        value: string;
        label: {
            text: string;
        };
        id: string;
        name: string;
        type?: string;
        hint?: {
            id?: string;
            text: string;
        };
        prefix?: import("./types.js").ComponentText;
        suffix?: import("./types.js").ComponentText;
        classes?: string;
        condition?: string;
        errors?: FormSubmissionError[];
        errorMessage?: {
            text: string;
        };
        summaryHtml?: string;
        html?: string;
        attributes: {
            autocomplete?: string;
            maxlength?: number;
            multiple?: string;
            accept?: string;
            inputmode?: string;
        };
        content?: import("./types.js").Content | import("./types.js").Content[] | string;
        maxlength?: number;
        maxwords?: number;
        rows?: number;
        items?: import("./types.js").ListItem[] | import("./types.js").DateInputItem[];
        fieldset?: {
            attributes?: string | Record<string, string>;
            legend?: import("./types.js").Label;
        };
        formGroup?: {
            classes?: string;
            attributes?: string | Record<string, string>;
        };
        showFieldsetError?: boolean;
        components?: import("./types.js").ComponentViewModel[];
        upload?: {
            count: number;
            summaryList: import("../../../../server/plugins/engine/types.js").SummaryList;
        };
    };
    getErrors(errors?: FormSubmissionError[]): FormSubmissionError[] | undefined;
    getViewErrors(errors?: FormSubmissionError[]): FormSubmissionError[] | undefined;
    isValue(value?: FormStateValue | FormState): value is GeospatialState;
    /**
     * For error preview page that shows all possible errors on a component
     */
    getAllPossibleErrors(): ErrorMessageTemplateList;
    /**
     * Static version of getAllPossibleErrors that doesn't require a component instance.
     */
    static getAllPossibleErrors(): ErrorMessageTemplateList;
}
